----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    
-- Design Name: 
-- Module Name:    EAU_PRE_ITER_c - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity EAU_PRE_ITER_c is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           vld_in : in  STD_LOGIC;
           fp_val_in : in  STD_LOGIC_VECTOR (63 downto 0);
			  int8_vld_out: out STD_LOGIC;
           int8_val_out : out  STD_LOGIC_VECTOR (10 downto 0);
			  fp_sub_vld_out: out STD_LOGIC;
           fp_sub_val_out : out  STD_LOGIC_VECTOR (31 downto 0));
end EAU_PRE_ITER_c;

architecture Behavioral of EAU_PRE_ITER_c is

component fpsp_2_int8 is
  port (
    rdy : out STD_LOGIC; 
    operation_nd : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    a : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    result : out STD_LOGIC_VECTOR ( 7 downto 0 ) 
  );
end component;

component fpsp_2_int11 is
  port (
    rdy : out STD_LOGIC; 
    operation_nd : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    a : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    result : out STD_LOGIC_VECTOR ( 10 downto 0 ) 
  );
end component;

signal rdy_conv1, rdy_conv2, op_nd_conv1, op_nd_conv2: std_logic;
signal  fp_val_in_shftd : std_logic_vector(63 downto 0);
signal t_int8_val_out: std_logic_Vector(10 downto 0);
signal t_fp8_6_val_out: std_logic_vector(20 downto 0);

component int8_2_fp8_6 is
  port (
    rdy : out STD_LOGIC; 
    operation_nd : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    a : in STD_LOGIC_VECTOR ( 7 downto 0 ); 
    result : out STD_LOGIC_VECTOR ( 14 downto 0 ) 
  );
end component;

component int11_2_fp11_9 is
  port (
    rdy : out STD_LOGIC; 
    operation_nd : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    a : in STD_LOGIC_VECTOR ( 10 downto 0 ); 
    result : out STD_LOGIC_VECTOR ( 20 downto 0 ) 
  );
end component;

component shift_reg_32b_12c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end component;

component dp_fp_sub is
  port (
    rdy : out STD_LOGIC; 
    operation_nd : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    a : in STD_LOGIC_VECTOR ( 63 downto 0 ); 
    b : in STD_LOGIC_VECTOR ( 63 downto 0 ); 
    result : out STD_LOGIC_VECTOR ( 63 downto 0 ) 
  );
end component;

signal rdy_sub1, vld_in_sub, vld_in_sub_r: std_logic;
signal fp_val_in_rdcd: std_logic_Vector(63 downto 0);

constant const_val : std_logic_Vector(20 downto 0):="001111111110000000000"; --  0000000000000000;
														--0011111111011111111111111101011000001110100101001110111000111001
component shift_reg_32b_23c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end component;

component CONTROL_PRE_ITER_FSM is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           vld_in : in  STD_LOGIC;
           sel : out  STD_LOGIC;
           vld_out : out  STD_LOGIC);
end component;

component MUX2_to_1_64 is
    Port ( sel : in  STD_LOGIC;
           A : in  STD_LOGIC_VECTOR (63 downto 0);
           B : in  STD_LOGIC_VECTOR (63 downto 0);
           RES : out  STD_LOGIC_VECTOR (63 downto 0));
end component;

component MUX2_to_1_21 is
    Port ( sel : in  STD_LOGIC;
           A : in  STD_LOGIC_VECTOR (20 downto 0);
           B : in  STD_LOGIC_VECTOR (20 downto 0);
           RES : out  STD_LOGIC_VECTOR (20 downto 0));
end component;

signal fp_val_in_rdcd_single: std_logic_Vector(31 downto 0);
signal sel: std_logic;
signal sub_A,sub_B: std_logic_Vector(63 downto 0);
signal sub_A_r, sub_B_r: std_logic_Vector(63 downto 0);
signal sub_B_s: std_logic_Vector(20 downto 0);

begin

SUB_MUX_A: MUX2_to_1_64 Port Map
( sel => sel,
  A => fp_val_in,
  B => fp_val_in_shftd,
  RES => sub_A
);





-------------------------------------------------------------------------
SUB_MUX_B: MUX2_to_1_21 Port Map
( sel => sel,
  A => const_val,
  B => t_fp8_6_val_out,
  RES => sub_B_s
);

sub_B(63 downto 43)<=sub_B_s;
sub_B(42 downto 0)<=(others=>'0');

vld_in_sub <= (vld_in and (not sel)) or (sel and rdy_conv2);

process(clk)
begin
if clk'event and clk='1' then
	sub_A_r<=sub_A;
	sub_B_r<=sub_B;
	vld_in_sub_r<=vld_in_sub;
end if;
end process;
	
	
	
-----------------------------------------------------------------------------	
REDUCE_INPUT: dp_fp_sub Port Map
(
    rdy => rdy_sub1,
    operation_nd => vld_in_sub_r,
    clk => clk, 
    a => sub_A_r, 
    b => sub_B_r,
    result => fp_val_in_rdcd
);
-------------------------------------------------------------------------------
op_nd_conv1<=rdy_sub1;


fp_val_in_rdcd_single(31 downto 30)<=fp_val_in_rdcd(63 downto 62);
fp_val_in_rdcd_single(29 downto 23)<=fp_val_in_rdcd(58 downto 52);
fp_val_in_rdcd_single(22 downto 0)<=fp_val_in_rdcd(51 downto 29);


fp_sub_val_out<=fp_val_in_rdcd_single;--fp_val_in_rdcd;
fp_sub_vld_out<=sel and rdy_sub1;




FPSP2INT8: fpsp_2_int11 Port Map
(
    rdy => rdy_conv1,
    operation_nd => op_nd_conv1, 
    clk => clk,
    a => fp_val_in_rdcd_single,--fp_val_in_rdcd,
    result => t_int8_val_out
);

int8_vld_out<=rdy_conv1;
int8_val_out<=t_int8_val_out;

op_nd_conv2<=rdy_conv1;

INT82FPSP: int11_2_fp11_9 Port Map
(
	 rdy => rdy_conv2, 
	 operation_nd => op_nd_conv2, 
	 clk => clk, 
	 a => t_int8_val_out,
	 result => t_fp8_6_val_out 
);  




--------------------------------------------------------------------------------------------
SHIFTER2: shift_reg_32b_23c Port Map  
(
    clk => clk,
    d => fp_val_in(63 downto 32),
    q => fp_val_in_shftd(63 downto 32)
);  
SHIFTER12: shift_reg_32b_23c Port Map  
(
    clk => clk,
    d => fp_val_in(31 downto 0),
    q => fp_val_in_shftd(31 downto 0)
);



CONTROL_PRE_ITER_FSM_C: CONTROL_PRE_ITER_FSM Port Map
( rst => rst,
  clk => clk,
  vld_in => vld_in,
  sel => sel,
  vld_out => open
);

end Behavioral;

