----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:36:20 04/07/2010 
-- Design Name: 
-- Module Name:    EAUmLUT - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity EAUmLUT is
    Port ( clk : in  STD_LOGIC;
           addr : in  STD_LOGIC_VECTOR (11 downto 0);
           data : out  STD_LOGIC_VECTOR (63 downto 0));
end EAUmLUT;

architecture Behavioral of EAUmLUT is

component EAU_mLUT is
  port (
    clka : in STD_LOGIC := 'X'; 
    addra : in STD_LOGIC_VECTOR ( 11 downto 0 ); 
    douta : out STD_LOGIC_VECTOR ( 26 downto 0 ) 
  );
end component;

signal LUT_data: std_logic_vector(26 downto 0);

component EAUmLUT_addrcomp is
  port (
    clk : in STD_LOGIC := 'X'; 
    qa_gt_b : out STD_LOGIC; 
    a : in STD_LOGIC_VECTOR ( 11 downto 0 ) 
  );
end component;

signal sel,sel_reg: std_logic;

signal t_data: std_logic_Vector(63 downto 0);

signal sel_vec,nsel_vec,tvec: std_logic_Vector(11 downto 0);
 
begin


MAINLUT: EAU_mLUT Port Map
(
 clka => clk,
 addra => addr, 
 douta => LUT_data 
);
  
MLUTCOMP: EAUmLUT_addrcomp Port Map
(
 clk => clk, 
 qa_gt_b => sel, 
 a =>  addr
);  

process(clk)
begin
if clk'event and clk='1' then
	sel_reg<=sel;
end if;
end process;

sel_vec<=(others=>sel_reg);
nsel_vec<=(others=> not sel_reg);
tvec<=(sel_vec and "010000000000") or (nsel_vec and "001111111111");

t_data(24 downto 0)<=(others=>'0');
t_data(51 downto 25)<=LUT_data;
t_data(63 downto 52)<=tvec;
data<=t_data;

end Behavioral;

