----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:25:07 04/29/2010 
-- Design Name: 
-- Module Name:    FSM_CONTROL_TOP - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity FSM_CONTROL_TOP is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           vld_in : in  STD_LOGIC;
           sel_1_s : out  STD_LOGIC;
           sel_iter : out  STD_LOGIC_VECTOR (3 downto 0);
			  arg_id : out STD_LOGIC_VECTOR(3 downto 0);
			  vld_o : out STD_LOGIC);
end FSM_CONTROL_TOP;

architecture Behavioral of FSM_CONTROL_TOP is

component FSM_MASTER is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           vld_in : in  STD_LOGIC;
           rst_s : out  STD_LOGIC;
           strt_s : out  STD_LOGIC;
			  ulock : in STD_LOGIC);
end component;

component FSM_SLAVE is
    Port ( rst : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           st : in  STD_LOGIC;
			  sel_1_s : out STD_LOGIC;
			  iter_id : out STD_LOGIC_VECTOR(3 downto 0);
			  arg_id : out STD_LOGIC_VECTOR(3 downto 0);
			  loop_ov : out STD_LOGIC;
			  vld_o : out STD_LOGIC);
end component;

signal rst_s, strt_s, ulock, ulock_r: std_logic;

begin

FM_C: FSM_MASTER Port Map
( rst => rst, 
  clk => clk,
  vld_in => vld_in,
  rst_s => rst_s,
  strt_s => strt_s,
  ulock => ulock_r
);

process(clk)
begin
if clk'event and clk='1' then
	ulock_r<=ulock;
end if;
end process;

FS_C: FSM_SLAVE Port Map
( rst => rst_s ,
  clk => clk,
  st => strt_s,
  sel_1_s => sel_1_s,
  iter_id => sel_iter,
  arg_id => arg_id ,
  loop_ov => ulock,
  vld_o => vld_o
);



end Behavioral;

